.\"	@(#)lharc.l 1.02A (Zorch) 10/6/90
.\"	Prepared by Kent Paul Dolan from the formatted documentation which was
.\"	distributed with Unix Lharc 1.02.  This document has been changed to
.\"	reflect the addition of the Amiga compatibility patch.  The original
.\"	was built to reflect a location as "man n lharc", but has been done
.\"	here, to reflect the storage on Zorch, as for "man l lharc".
.\"
.TH LHARC L "October 6, 1990"
.SH NAME
.B lharc
\- Archiver with a very efficient compression method
.SH SYNOPSIS
.PU
.ll +8
.B lharc
{
.I key
}[
.I options
]
.I archive\_file
[
.I "name \&..."
]
.ll -8
.SH DESCRIPTION
.I LHarc
is an archiver which incorporates an efficient compression algorithm.
The author created an improved compression method by combining the
.I LZHUF
method with the
.I adaptive huffman
method, thus incorporating both into his archiver.
The original version was developed under
.I MS\-DOS.
.I UNIX
.I LHarc
is a derivative work which provides archive compatibility on
.I UNIX
systems.
.PP
.I LHarc
expects the name of the archive file in
.I archive\_file.
If the specified file does not exist,
.I LHarc
automatically appends
.I .lzh
to the argument, then tries again.
Although it is not a requirement for the proper operation of
.I LHarc,
it is recommended to append
.I .lzh
as the standard suffix for the archive file name.
There is a special case to support
.I MS\-DOS
needs; when the archive file name given to
.I LHarc
has
.I .com
or
.I .exe
as its suffix, then
.I LHarc
examines the file to determine if it is a
.I SFX
.I (SelF\-eXtract)
archive created by
.I MS\-DOS;
if so,
.I UNIX
.I LHarc
then acts appropriately(!?!).
However,
.I UNIX
.I LHarc
cannot create an
.I SFX
archive.
Since it cannot do so, in case additions or deletions are done with
.I UNIX
.I LHarc
upon the
.I SFX
archive,
.I UNIX
.I LHarc
creates a newer archive with
.I .lzh
as its suffix,
in which any
.I SFX
information will be truncated(!?!).
.SH KEYS
The first argument,
.I key,
denotes one of the following:
.TP 8
.B a
.I addition.
Append files specified by
.I name
onto the archive.
In case
.I name
was a directory,
.I LHarc
will append all of the files under
.I name.
.TP 8
.BR x \ or\  e
.I extraction.
.I LHarc
extracts those files specified by
.I name,
or, if no files were specified, extracts all files in the archive.
.TP 8
.BR l \ or\  v
.I listing.
.I LHarc
lists archived files (i.e. contents of archive) specified by
.I name.
With no argument,
.I LHarc
lists all files in the archive.
.I 'v'
instructs
.I LHarc
to list the contents of archive in detail.
.TP 8
.B u
.I update.
.I LHarc
adds the files specified by
.I name,
comparing each file with the corresponding one in the archive.
It adds the file to the archive if it is newer, or if the file doesn't
currently exist in the archive.
With no
.I name
specified,
.I LHarc
updates the archive by scanning every corresponding file(!?!).
.TP 8
.B d
.I delete.
Delete files, specified by
.I name,
from the archive.
.TP 8
.B m
.I move.
After storing files, specified by
.I name,
into the archive,
.I LHarc
removes the unarchived originals.
This is equivalent to specifying
.I 'ad'
for
.I key
and
.I option.
.TP 8
.B c
.I create.
Discards the contents of the archive, then creates a new archive,
storing files designated by
.I name.
.TP 8
.B p
.I print.
Extract from the archive the files specified by
.I name
(or the whole contents of the archive if
.I name
is not specified), onto the standard output.
.SH OPTIONS
Additional attributes can be specified with
.I options,
as described below.
.TP 8
.B q
.I quiet.
Suppress messages.
.TP 8
.B v
.I verbose.
Display verbose message.
.TP 8
.B n
.I no execution.
This option was provided to ascertain what
.I LHarc
will do without doing it.
.TP 8
.B f
.I force.
On extraction from the archive, don't even ask if the named file already
exists in the target directory.
Old files will be overwritten quietly.
When storing into the archive,
.I LHarc
specifies the
.I 'm'
and
.I 'd'
options automatically, thus avoiding query in case there
is some difficulty in removing the files.
.TP 8
.B t
.I text mode.
Convert 
.IR UNIX \-style
line termination (newline\-code), to 
.I MS\-DOS
style line termination (carriage\-return and line\-feed codes)
to maintain text portability with
.I MS\-DOS
.I LHarc.
.TP 8
.B g
.I generic.
Remove operating system dependencies from the archive to make the archive
information
.I generic.
If you are worried about archive compatibility, don't specify directories
when adding files to the archive, since the existence of pathnames in the
archive may not work when the files are extracted to the target operating
system.
.I LHarc
ignores uppercase/lowercase in file names in
.I generic
 mode, although they are shown in lowercase, when using the
.I 'l'
or
.I 'v'
.RB ( listing )
commands.
.TP 8
.B A
.I Amiga mode.
A less drastic form of compatibility mode than
.I generic,
which lets archives created with
.I UNIX
.I LHarc
be downloaded to and used by
.I Commodore Amiga
computers, under
.I Amiga
.I LHarc.
.TP 8
.B d
.I discard.
Remove the unarchived copies of files after they have been archived.
Note that existing, outdated copies of files will
.I also
be discarded when
.I 'd'
is used together with the
.I 'u'
.RI ( update )
command and the corresponding file in the archive is newer than the
unarchived file of the same
.I name.
.SH FILES
.DT
*.lzh		\- extension of archive, by default
*.bak		\- backup files
/tmp/lh*	\- temporary files
*.com *.exe	\- MS-DOS SFX files
.SH SEE ALSO
.BR tar (1),
.BR ar (1),
.BR compress (1)
.SH DISTRIBUTION
This software is
.I Copyrighted
09/19/1989 by
.I Yooichi Tagawa,
Tokyo, Japan.
The author allows free distribution under the following conditions:
.TP 8
.B 1.
This copyright notice is maintained.
.TP 8
.B 2.
As for contents of distribution,
.RS +8
.TP 8
.B a.
All files in the standard distribution (e.g. source code, documents,
guide to programmers) must exist in any re-distribution.
If they were modified, modifications must be clearly indicated.
.TP 8
.B b.
If any kind of valuable capabilities, programs, or information were added
within a re-distribution, the distributor doing the modifications must make
every effort to include them in the next distribution.
In such case, decent documents describing the new programs or additional
capabilities must be prepared.
.TP 8
.B c.
Do not distribute
.I LHarc
in binary only.
(This also pertains to added programs or information).
.RS -8
.TP 8
.B 3.
You must make an effort to distribute the newest version
(but it's not your mandatory duty).
.TP 8
.B 4.
This program comes with no warranty, expressed or implied.
Use of this program is at the entire risk of the user.
.TP 8
.B 5.
The current author has no duty to correct mistakes, if any, in this program.
.TP 8
.B 6.
Parts of this program, or the whole program may be freely
incorporated into other programs.
In such case, the resulting program is not allowed to be called
.I LHarc.
.TP 8
.B 7.
For use of this program for commercial purposes, in addition to the above
conditions, the following conditions also apply.
.RS +8
.TP 8
.B a.
Commercial use which consists solely or principally of this program as a
product for sale, is prohibited.
.TP 8
.B b.
If the purchaser or licensee of a commercial product including
.I LHarc
in its distribution
is judged likely to make improper use of this program,
or refuses to comply with these restrictions, distribution of
.I LHarc
with the commercial product to that user is forbidden.
.TP 8
.B c.
If
.I LHarc
is used as a means of installing commercial software, the vendor of
the commercial software is not allowed to require the user to do
that installation.
In this case, the commercial vendor must do the installation.
All damages caused by use of
.I LHarc
in such an installation are the responsibility of the commercial vendor.
.TP 8
.B d.
If
.I LHarc
is included as part of a commercial product, the vendor of that product
must support this program.
.RS -8
.SH ACKNOWLEDGEMENTS
Thanks to
.I Haruhiko Okumura
for his development of the
.I LZARI
method, on which
.I LZHUF
was based.
Thanks to
.I Haruhiko Miki
for
.I LArc,
and thanks to
.I Yasuaki Yoshizaki
for his derivative work from
.I LArc,
thus making up the
.I LZHUF
method and
.I MS\-DOS
.I LHarc.
Thanks to the many people who assisted the development of
.I LHarc,
.I Kazuaki Ishibashi
for forwarding mail (between commercial BBS's),
all
.I beta testers
who reported various results, and the person who forwarded this information,
.I Koichiro Mori.
.PP
This manual was translated by
.I Youki Kadobayashi
<youki@mercury.ics.osaka-u.ac.jp>.
Although I made every possible effort I could, there may be mistakes or
queer expressions.
Feel free to correct my mistakes, I will appreciate your feedback.
.PP
You can distribute this English version of the manual page,
under the same
.I DISTRIBUTION
conditions described above.
.PP
(This manual was restored from a formatted copy,
included with the release 1.02 distribution,
back to {n,t}roff input format,
with lots of editorial corrections,
on 6 October 1990,
by
.I Kent Paul Dolan,
<xanthian@Zorch.SF\-Bay.ORG>
<xanthian@well.sf.ca.us>.
Remaining grammer and spelling errors are mine,
as well as any incorrect descriptions of program operation I may have
introduced by mistake.
Things I couldn't understand to improve are marked "(!?!)".
(Sorry about those!)
I did my very best to make good sense out of the distribution conditions,
which made little sense as received;
I think they now represent the author's intent in the usual English
terminology.)
